#!/usr/bin/perl -w
# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..10\n"; }
END {print "not ok 1\n" unless $loaded;}
use Crypt::Store::Tie;
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):


use strict;
BEGIN { @AnyDBM_File::ISA=qw(DB_File ODBM_File SDBM_File NDBM_File) }
use AnyDBM_File;
use Digest::MD5;
use Crypt::IDEA;
use Fcntl;

my %store;
tie %store, 'AnyDBM_File', 'test.cryptodb', O_CREAT|O_RDWR, 0600;
die "Can't tie test.cryptodb: $!\n" unless tied %store;

my %crypt;
tie %crypt, 'Crypt::Store::Tie',
                STORE=>\%store;

print "ok 2\n";

my $secret=pack("H32", "0123456789ABCDEF" x 2);
my $secret2=pack("H32", "FEDCBA9876543210" x 2);

#print "not " if exists $crypt{$secret};
print "ok 3\n";

$crypt{$secret}="Some data";
print "ok 4\n";

print "not " unless exists $crypt{$secret};
print "ok 5\n";

print "not " unless $crypt{$secret} eq 'Some data';
print "ok 6\n";

my $foo="\xFF\xAD\x00\x00";

$crypt{$secret}=$foo;
print "not " unless $crypt{$secret} eq $foo;
print "ok 7\n";

$crypt{$secret2}="YAADDA";
print "not " unless $crypt{$secret} eq $foo;
print "ok 8\n";

delete $crypt{$secret};
print "not " if exists $crypt{$secret};
print "ok 9\n";

print "not " unless exists $crypt{$secret2};
print "ok 10\n";

untie %crypt;

unlink "test.cryptodb" or warn "Unable to unlink test.cryptodb: $!\n";


########################################################
package SDBM_File;
sub EXISTS
{
    my($self, $key)=@_;
    return defined $self->FETCH($key);
}
package NDBM_File;
sub EXISTS
{
    my($self, $key)=@_;
    return defined $self->FETCH($key);
}
